program AVR_RC5rxtx;

{$NOSHADOW}

Device = mega128, VCC=5;

Define_Fuses
  LockBits0      = [];
  FuseBits0      = [BODEN];
  FuseBits1      = [CKOPT, SPIEN, JTAGEN, OCDEN];
  FuseBits2      = [];
  ProgMode       = JTAG;

Import SysTick, RC5Rxport, RC5Txport, LCDmultiPort, TWImaster, BeepPort;

From System Import ;

Define
  ProcClock    = 16000000;        {Hertz}
  SysTick      = 10;              {msec}
  StackSize    = $0020, iData;
  FrameSize    = $0040, iData;
  
  RC5RxPort    = PinE, 2, negative;
  RC5TXPORT    = Timer3, negative;       {Timer, pulse polarity, carrier freq}
  RC5mode      = rc_7bit;
  
  BeepPort     = PortG, 4;
  
  TWIpresc     = TWI_BR400;
  LCDmultiPort = I2C_TWI;
  LCDrows_M    = 4;               {rows}
  LCDcolumns_M = 20;              {columns per line}
  LCDtype_M    = 44780;
  

Implementation

{$IDATA}

{--------------------------------------------------------------}
{ Type Declarations }

type


{--------------------------------------------------------------}
{ Const Declarations }


{--------------------------------------------------------------}
{ Var Declarations }
{$IDATA}
var
  rxAdr           : byte;
  rxCmd           : byte;
  txAdr           : byte;
  txCmd           : byte;
  bool            : boolean;
  bb              : byte;

{--------------------------------------------------------------}
{ functions }
procedure InitPorts;
begin
  // PinE.2  = Rx
  // PortE.3 = Tx Timer3 OutpCompA
  DDRE:= (DDRE and $F3) or $8;         // RC5rxPin inp, RC5txPin outp
end;

{--------------------------------------------------------------}
{ Main Program }
{$IDATA}

begin
  txCmd:= 1;
  txAdr:= 0;
  InitPorts;
  LCDsetup_M(LCD_m1);
  LCDcursor_M(LCD_m1, true, false);
  Write(LCDOut_M,  'E-LAB EvaBoard');
  LCDxy_M(LCD_m1, 0, 1);
  Write(LCDOut_M,  'RC5 Rx/Tx Test');

  EnableInts;
  loop
    if RecvRC5(rxAdr, rxCmd) then
      LCDxy_M(LCD_m1, 0, 2);
      LCDclrLine_M(LCD_m1, 2);
      Write(LCDout_M, ByteToHex(rxAdr)+ '  ');
      Write(LCDout_M, ByteToHex(rxCMD));
      rxCmd:= rxCmd and $3F;
      BeepClick;
    else
     SendRC5(txAdr, txCmd);
     inc(txCmd);
     if txCmd > 10 then
       txCmd:= 1;
       inc(txAdr);
     endif;
     mDelay(87);
    endif;
  endloop;
end AVR_RC5rxtx.


